# PF Class Reference

Trivial particle filter with proposal density equal to parameter evolution model. More...

`#include <libPF.h>`

Inheritance diagram for PF:

[legend]
Collaboration diagram for PF:

[legend]

List of all members.

## Public Member Functions
| PF (const RV &rv0, mpdf &par0, mpdf &obs0, int n0)
| Default constructor.
void | set_est (const epdf &epdf0)
| Set posterior density by sampling from epdf0.
void | bayes (const vec &dt)
| Incremental Bayes rule.
vec * | __w ()
| access function
virtual void | bayesB (const mat &Dt)
| Batch Bayes rule (columns of Dt are observations).
virtual const epdf & | _epdf () const =0
| Returns a reference to the epdf representing posterior density on parameters.
virtual const epdf * | _e () const =0
| Returns a pointer to the epdf representing posterior density on parameters. Use with care!
virtual double | logpred (const vec &dt) const
vec | logpred_m (const mat &dt) const
| Matrix version of logpred.
virtual epdf * | predictor (const RV &rv) const
| Constructs a predictive density (marginal density on data).
const RV & | _rv () const
| access function
double | _ll () const
| access function
void | set_evalll (bool evl0)
| access function
virtual BM * | _copy_ (bool changerv=false)
## Protected Attributes
int | n
| number of particles;
eEmp | est
| posterior density
vec & | _w
| pointer into `eEmp`
Array< vec > & | _samples
| pointer into `eEmp`
mpdf & | par
| Parameter evolution model.
mpdf & | obs
| Observation model.
RV | rv
| Random variable of the posterior.
double | ll
| Logarithm of marginalized data likelihood.
bool | evalll
| If true, the filter will compute likelihood of the data record and store it in `ll` . Set to false if you want to save computational time.

## Detailed Description

Trivial particle filter with proposal density equal to parameter evolution model.

Posterior density is represented by a weighted empirical density (`eEmp` ).

## Member Function Documentation

void PF::bayes | ( | const vec & | dt | ) | `[virtual]`

Incremental Bayes rule.

Parameters:

  | dt | vector of input data

Implements BM.

Reimplemented in MPF< BM_T >.

References _samples, _w, est, mpdf::evallogcond(), n, obs, par, eEmp::resample(), and mpdf::samplecond().

virtual double BM::logpred | ( | const vec & | dt | ) | const`[inline, virtual, inherited]`

Evaluates predictive log-likelihood of the given data record I.e. marginal likelihood of the data with the posterior integrated out.

Reimplemented in ARX, MixEF, and multiBM.

Referenced by BM::logpred_m().

virtual BM* BM::_copy_ | ( | bool | changerv = `false` | ) | `[inline, virtual, inherited]`

Copy function required in vectors, Arrays of BM etc. Have to be DELETED manually! Prototype: BM* _copy_(){BM Tmp*=new Tmp(this*); return Tmp; }

Reimplemented in ARX, and BMEF.

The documentation for this class was generated from the following files:

- work/git/mixpp/bdm/estim/libPF.h
- work/git/mixpp/bdm/estim/libPF.cpp